;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; JumpGen v0.11b (Feb. 14, 2001)                            ;
;                                                           ;
; Calculates VB PCode jumps easily.  VB PCode jumps always  ;
; jump from the start of the current procedure.  In order   ;
; to calcluate them by hand, you subtract the proc address  ;
; from the location to jump to.  Then you convert it to hex ;
; (if it isn't already in hex) and reverse the 2 bytes of   ;
; the result.  You then use the prefix 1C for BranchF, 1D   ;
; for BranchT, and 1E for Branch.                           ;
;                                                           ;
; by Muad'Dib and noptical                                  ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



.386
.model flat,stdcall
option casemap:none

include     \masm32\include\windows.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\user32.inc
include     \masm32\include\masm32.inc
include     \masm32\include\comctl32.inc

includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\masm32.lib
includelib  \masm32\lib\comctl32.lib

MainDialog  PROTO   :DWORD,:DWORD,:DWORD,:DWORD
PCodeDialog PROTO   :DWORD,:DWORD,:DWORD,:DWORD
Sixty8kDialog   PROTO   :DWORD,:DWORD,:DWORD,:DWORD
x86Dialog   PROTO   :DWORD,:DWORD,:DWORD,:DWORD

.data
branchFhex  db      "1C%.8X",0        ; wsprintf allows us to put something before the specifier, hence !!%.8X
branchThex  db      "1D%.8X",0        ; fixed bug for v0.11b+ (was !!%X in v0.1b)
branchhex   db      "1E%.8X",0

longjmphex  db      "E9%.8X",0
shortjmphex db      "EB%.8X",0
jcxzhex     db      "E3%.8X",0

tabpcode    db      "P-Code",0
tab68k      db      "68k",0
tabx86      db      "x86",0

jumps       db      "JMP",0,0
            db      "JA",0,0,0
            db      "JAE",0,0
            db      "JB",0,0,0
            db      "JBE",0,0
            db      "JC",0,0,0
            db      "JE",0,0,0
            db      "JG",0,0,0
            db      "JGE",0,0
            db      "JL",0,0,0
            db      "JLE",0,0
            db      "JNA",0,0
            db      "JNAE",0
            db      "JNB",0,0
            db      "JNBE",0
            db      "JNC",0,0
            db      "JNE",0,0
            db      "JNG",0,0
            db      "JNGE",0
            db      "JNL",0,0
            db      "JNLE",0
            db      "JNO",0,0
            db      "JNP",0,0
            db      "JNS",0,0
            db      "JNZ",0,0
            db      "JO",0,0,0
            db      "JP",0,0,0
            db      "JPE",0,0
            db      "JPO",0,0
            db      "JS",0,0,0
            db      "JZ",0,0,0
            db      "JCXZ",0
            db      "JECXZ",0


shortjmps   db      "77%.8X",0
            db      "73%.8X",0
            db      "72%.8X",0
            db      "76%.8X",0
            db      "72%.8X",0
            db      "74%.8X",0
            db      "7F%.8X",0
            db      "7D%.8X",0
            db      "7C%.8X",0
            db      "7E%.8X",0
            db      "76%.8X",0
            db      "72%.8X",0
            db      "73%.8X",0
            db      "77%.8X",0
            db      "73%.8X",0
            db      "75%.8X",0
            db      "7E%.8X",0
            db      "7C%.8X",0
            db      "7D%.8X",0
            db      "7F%.8X",0
            db      "71%.8X",0
            db      "7B%.8X",0
            db      "79%.8X",0
            db      "75%.8X",0
            db      "70%.8X",0
            db      "7A%.8X",0
            db      "7A%.8X",0
            db      "7B%.8X",0
            db      "78%.8X",0
            db      "74%.8X",0

longjmps    db      "0F87%.8X",0
            db      "0F83%.8X",0
            db      "0F82%.8X",0
            db      "0F86%.8X",0
            db      "0F82%.8X",0
            db      "0F84%.8X",0
            db      "0F8F%.8X",0
            db      "0F8D%.8X",0
            db      "0F8C%.8X",0
            db      "0F8E%.8X",0
            db      "0F86%.8X",0
            db      "0F82%.8X",0
            db      "0F83%.8X",0
            db      "0F87%.8X",0
            db      "0F83%.8X",0
            db      "0F85%.8X",0
            db      "0F8E%.8X",0
            db      "0F8C%.8X",0
            db      "0F8D%.8X",0
            db      "0F8F%.8X",0
            db      "0F81%.8X",0
            db      "0F8B%.8X",0
            db      "0F89%.8X",0
            db      "0F85%.8X",0
            db      "0F80%.8X",0
            db      "0F8A%.8X",0
            db      "0F8A%.8X",0
            db      "0F8B%.8X",0
            db      "0F88%.8X",0
            db      "0F84%.8X",0
            
            


errormsg            db  "Error...",0

nolongjcxz          db  "JCXZ/JECXZ is a SHORT opcode only!",0

notimplemented      db  "68k jumps are not yet implemented!",0

titlebar            db  "Muad'Dib & noptical's jumpgen v0.4b",0

.data?
hInst       dd      ?                   ; instance
szProcAddr  db      10h     dup(?)      ; string for Proc Address
szJumpTo    db      10h     dup(?)      ; string for Jump To address
szJumpFrom  db      10h     dup(?)
procaddr    dd      ?                   ; integer for Proc Address
jumpfrom    dd      ?
jumpto      dd      ?                   ; integer for Jump To address
generated   db      10h     dup(?)      ; string for generated opcode
temp        db      10h     dup(?)
tabstruct   TC_ITEM <?>
hWndTabs    dd      ?
hWndMain    dd      ?

hWndPCode   dd      ?
hWndx86     dd      ?
hWnd68k     dd      ?

.code
main:

    invoke  GetModuleHandle, 0          ; get the instance
    mov     hInst, eax                  ; save it
    call    InitCommonControls          ; initialize common controls, duh
    invoke  DialogBoxParam, hInst, 1, 0, OFFSET MainDialog, 0   ; bring up a dialog
    invoke  ExitProcess, 0

MainDialog  PROC    uses ebx    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    .if     uMsg == WM_CLOSE                ; if they click "x"...
        invoke  EndDialog, hWnd, 0          ; exit
        ret                                 ; and return from the process

    .elseif uMsg == WM_INITDIALOG

        push    hWnd
        pop     hWndMain

        invoke  SetWindowText, hWnd, OFFSET titlebar
                
        mov     tabstruct.imask, TCIF_TEXT
        mov     tabstruct.pszText, OFFSET tabpcode
        mov     tabstruct.cchTextMax, SIZEOF tabpcode
        invoke  SendDlgItemMessage, hWnd, 1000, TCM_INSERTITEM, 0, OFFSET tabstruct

        mov     tabstruct.pszText, OFFSET tab68k
        mov     tabstruct.cchTextMax, SIZEOF tab68k
        invoke  SendDlgItemMessage, hWnd, 1000, TCM_INSERTITEM, 0, OFFSET tabstruct

        mov     tabstruct.pszText, OFFSET tabx86
        mov     tabstruct.cchTextMax, SIZEOF tabx86
        invoke  SendDlgItemMessage, hWnd, 1000, TCM_INSERTITEM, 0, OFFSET tabstruct

        invoke  GetDlgItem, hWnd, 1000
        mov     hWndTabs, eax
        invoke  CreateDialogParam, hInst, 2, hWndTabs, OFFSET PCodeDialog, 0
        invoke  CreateDialogParam, hInst, 3, hWndTabs, OFFSET Sixty8kDialog, 0
        invoke  CreateDialogParam, hInst, 4, hWndTabs, OFFSET x86Dialog, 0
        invoke  SendDlgItemMessage, hWnd, 1000, TCM_SETCURSEL, 0, 0
        invoke  ShowWindow, hWndx86, SW_SHOW
        invoke  ShowWindow, hWnd68k, SW_HIDE
        invoke  ShowWindow, hWndPCode, SW_HIDE

    .elseif uMsg == WM_NOTIFY
            mov     eax, lParam
            mov     eax, (NMHDR PTR [EAX]).code
            .if     eax == TCN_SELCHANGE
                invoke  SendDlgItemMessage, hWnd, 1000, TCM_GETCURSEL, 0, 0
                .if     eax == 0
                    invoke  ShowWindow, hWndx86, SW_SHOW
                    invoke  ShowWindow, hWnd68k, SW_HIDE
                    invoke  ShowWindow, hWndPCode, SW_HIDE
                .elseif eax == 1
                    invoke  ShowWindow, hWnd68k, SW_SHOW
                    invoke  ShowWindow, hWndx86, SW_HIDE
                    invoke  ShowWindow, hWndPCode, SW_HIDE
                .elseif eax == 2
                    invoke  ShowWindow, hWndPCode, SW_SHOW
                    invoke  ShowWindow, hWnd68k, SW_HIDE
                    invoke  ShowWindow, hWndx86, SW_HIDE
                .endif
            .endif
    .endif

xor     eax, eax                                        ; make windows NT compatible (required USES EBX in
                                                        ; proc definitoin, too)
ret

MainDialog  ENDP

PCodeDialog     PROC    uses ebx    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    .if     uMsg == WM_INITDIALOG
        invoke  SendDlgItemMessage, hWnd, 202, BM_SETCHECK, BST_CHECKED, 0      ; we need "branch" to be checked
        push    hWnd
        pop     hWndPCode

    .elseif uMsg == WM_COMMAND
        mov     eax, wParam                                                     ; wparam contains the control ID
        .if     ax == 100

@startcalc:
            invoke  GetDlgItemText, hWnd, 300, OFFSET szProcAddr, 10h           ; get Proc Address string
            invoke  GetDlgItemText, hWnd, 301, OFFSET szJumpTo, 10h             ; get Jump To string
            invoke  htodw, OFFSET szProcAddr                                    ; convert Proc Address to integer
            mov     procaddr, eax                                               ; save it
            invoke  htodw, OFFSET szJumpTo                                      ; convert Jump To to integer
            mov     jumpto, eax                                                 ; save it

            mov     eax, procaddr                                               ; load proc address
            mov     ebx, jumpto                                                 ; load jump to
            cmp     ebx, eax                                                    ; compare them
            jg      @valid                                                      ; if procaddr > jumpto
            invoke  SetDlgItemText, hWnd, 302, OFFSET errormsg                  ; tell them
            ret                                                                 ; and stop execution until clicked again

@valid:
            sub     ebx, eax                    ; if valid
            xchg    bl, bh                      ; we exhcange bl and BH (8 bits) so that they are backwards
            rol     ebx, 16                     ; then we put them at the front of EBX (so ebx will be backwards)
            xchg    bl, bh                      ; and we exchange the new bl and bh so everything is backwards

            push    ebx                         ; preserve ebx
            
            invoke  SendDlgItemMessage, hWnd, 200, BM_GETCHECK, 0, 0        ; is BranchF checked?
            cmp     eax, BST_CHECKED                                        ; ...
            jz      @branchF                                                ; yes, go to branchf handler

            invoke  SendDlgItemMessage, hWnd, 201, BM_GETCHECK, 0, 0        ; is branchT checked?
            cmp     eax, BST_CHECKED                                        ; ...
            jz      @branchT                                                ; yes, go to branchT handler

            pop     ebx                                                     ; branch was checked (if nothing else
                                                                            ; is, this is obviously the case) so
                                                                            ; restore ebx
            invoke  wsprintf, OFFSET generated, OFFSET branchhex, ebx       ; convert it
            mov     byte ptr [generated + 6], 0                             ; truncate it to 6 characters (3 bytes)
            invoke  SetDlgItemText, hWnd, 302, OFFSET generated             ; display it!
            ret                                                             ; stop execution

@branchF:
            pop     ebx                                                     ; same as before....
            invoke  wsprintf, OFFSET generated, OFFSET branchFhex, ebx
            mov     byte ptr [generated + 6], 0
            invoke  SetDlgItemText, hWnd, 302, OFFSET generated
            ret

@branchT:
            pop     ebx                                                     ; same again....
            invoke  wsprintf, OFFSET generated, OFFSET branchThex, ebx
            mov     byte ptr [generated + 6], 0
            invoke  SetDlgItemText, hWnd, 302, OFFSET generated
            ret


        .elseif     eax == 101                          ; if the user clicked "exit"
            invoke  EndDialog, hWndMain, 0              ; then we exit!
            ret                                         ; ret!

        .elseif ax == 300 || ax == 301
            rol     eax, 16
            .if     ax == EN_UPDATE
                jmp     @startcalc
            .endif            

        .elseif ax == 200 || ax == 201 || ax == 202
            jmp     @startcalc
            

        .endif
    .endif

xor     eax, eax
ret

PCodeDialog     ENDP

Sixty8kDialog   PROC    uses ebx    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    .if     uMsg == WM_INITDIALOG
        push    hWnd
        pop     hWnd68k

    .elseif uMsg == WM_COMMAND
    mov     eax, wParam
        .if     ax == 100
            invoke  MessageBox, hWndMain, OFFSET notimplemented, 0, MB_ICONERROR
        .elseif     eax == 101                          ; if the user clicked "exit"
            invoke  EndDialog, hWndMain, 0              ; then we exit!
            ret                                         ; ret!

        .endif
    .endif

xor     eax, eax
ret

Sixty8kDialog   ENDP

x86Dialog       PROC    uses ebx    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    .if     uMsg == WM_INITDIALOG

        mov     ebx, OFFSET jumps
        mov     ecx, 0
@comboloop:
        push    ebx
        push    ecx
        invoke  SendDlgItemMessage, hWnd, 200, CB_ADDSTRING, 0, ebx
        pop     ecx
        pop     ebx
        add     ebx, 5
        inc     ecx
        cmp     ecx, 32
        jl      @comboloop

        invoke  SendDlgItemMessage, hWnd, 200, CB_SETCURSEL, 0, 0
        
        push    hWnd
        pop     hWndx86        

    .elseif uMsg == WM_COMMAND
        mov     eax, wParam
        .if     ax == 100

@startcalc:

            invoke  GetDlgItemText, hWnd, 300, OFFSET szJumpFrom, 10h           ; get Proc Address string
            invoke  GetDlgItemText, hWnd, 301, OFFSET szJumpTo, 10h             ; get Jump To string
            invoke  htodw, OFFSET szJumpFrom                                    ; convert Proc Address to integer
            mov     jumpfrom, eax                                               ; save it
            invoke  htodw, OFFSET szJumpTo                                      ; convert Jump To to integer
            mov     jumpto, eax                                                 ; save it
            mov     eax, jumpfrom
            mov     ebx, jumpto
            sub     ebx, eax
            .if     ((ebx >= -128) || (ebx <= 127))
            
                invoke  SendDlgItemMessage, hWnd, 200, CB_GETCURSEL, 0, 0
                cmp     eax, 0
                jnz     @notjmp

                mov     eax, jumpfrom
                mov     ebx, jumpto
                sub     ebx, eax
                sub     ebx, 2
                xchg    bl, bh                      ; we exhcange bl and BH (8 bits) so that they are backwards
                rol     ebx, 16                     ; then we put them at the front of EBX (so ebx will be backwards)
                xchg    bl, bh                      ; and we exchange the new bl and bh so everything is backwards

                invoke  wsprintf, OFFSET generated, OFFSET shortjmphex, ebx     ; convert it
                mov     byte ptr [generated + 4], 0
                invoke  SetDlgItemText, hWnd, 302, OFFSET generated             ; display it!
                ret                                                             ; stop execution

@notjmp:
                cmp     eax, 31
                jl      @notjcxz

                mov     eax, jumpfrom
                mov     ebx, jumpto
                sub     ebx, eax
                sub     ebx, 2
                xchg    bl, bh                      ; we exhcange bl and BH (8 bits) so that they are backwards
                rol     ebx, 16                     ; then we put them at the front of EBX (so ebx will be backwards)
                xchg    bl, bh                      ; and we exchange the new bl and bh so everything is backwards
    
                invoke  wsprintf, OFFSET generated, OFFSET jcxzhex, ebx         ; convert it
                mov     byte ptr [generated + 4], 0
                invoke  SetDlgItemText, hWnd, 302, OFFSET generated             ; display it!
                ret                                                             ; stop execution
@notjcxz:

                mov     ecx, OFFSET shortjmps
                dec     eax
                imul    eax, 7
                add     ecx, eax


                mov     eax, jumpfrom
                mov     ebx, jumpto
                sub     ebx, eax
                sub     ebx, 2
                xchg    bl, bh                      ; we exhcange bl and BH (8 bits) so that they are backwards
                rol     ebx, 16                     ; then we put them at the front of EBX (so ebx will be backwards)
                xchg    bl, bh                      ; and we exchange the new bl and bh so everything is backwards

                invoke  wsprintf, OFFSET generated, ecx, ebx
                mov     byte ptr [generated + 4], 0
                invoke  SetDlgItemText, hWnd, 302, OFFSET generated

            .else

                invoke  SendDlgItemMessage, hWnd, 200, CB_GETCURSEL, 0, 0
                cmp     eax, 0
                jnz     @notjmp2

                mov     eax, jumpfrom
                mov     ebx, jumpto
                sub     ebx, eax
                sub     ebx, 5
                xchg    bl, bh                      ; we exhcange bl and BH (8 bits) so that they are backwards
                rol     ebx, 16                     ; then we put them at the front of EBX (so ebx will be backwards)
                xchg    bl, bh                      ; and we exchange the new bl and bh so everything is backwards

                invoke  wsprintf, OFFSET generated, OFFSET longjmphex, ebx      ; convert it
                invoke  SetDlgItemText, hWnd, 302, OFFSET generated             ; display it!
                ret                                                             ; stop execution

@notjmp2:
                cmp     eax, 31
                jl      @notjcxz2

                invoke  MessageBox, hWnd, OFFSET nolongjcxz, 0, MB_ICONERROR
                invoke  SetDlgItemText, hWnd, 302, 0
                ret
@notjcxz2:

                mov     ecx, OFFSET longjmps
                dec     eax
                imul    eax, 9
                add     ecx, eax


                mov     eax, jumpfrom
                mov     ebx, jumpto
                sub     ebx, eax
                sub     ebx, 6
                xchg    bl, bh                      ; we exhcange bl and BH (8 bits) so that they are backwards
                rol     ebx, 16                     ; then we put them at the front of EBX (so ebx will be backwards)
                xchg    bl, bh                      ; and we exchange the new bl and bh so everything is backwards

                invoke  wsprintf, OFFSET generated, ecx, ebx
                invoke  SetDlgItemText, hWnd, 302, OFFSET generated
            
            .endif
                
        .elseif ax == 101
            invoke  EndDialog, hWndMain, 0
            ret

        .elseif ax == 300 || ax == 301
            rol     eax, 16
            .if     ax == EN_UPDATE
                jmp     @startcalc
            .endif

        .elseif ax == 200
            rol     eax, 16
            .if     ax == LBN_SELCHANGE
                jmp     @startcalc
            .endif
            
            
        .endif

    .endif

xor     eax, eax
ret

x86Dialog       ENDP

end main